<?
if (!defined("B_PROLOG_INCLUDED") || B_PROLOG_INCLUDED!==true)die();

class CBPSetPermissionsActivityExRights
	extends CBPActivity
{
	const AddPermissions = 1;	// Добавляем права БП, приоритет старых прав элемента и БП
	const RewritePermissions = 2;	// Перетираем старые права БП при совпадении, приоритет прав элемента
	const ClearPermissions = 3;	// Удаляем старые полномочия БП, приоритет прав элемента
	const RewriteAllPermissions = 4;// Перетираем любые полномочия при совпадении, приоритет новых прав БП
	const ClearAllPermissions = 5;	// Удаляем все старые полномочия
	
	public function __construct($name)
	{
		parent::__construct($name);
		$this->arProperties = array(
			"Title" => "",
			"Permission" => array(),
			"Rewrite" => self::ClearPermissions,
		);
	}

	public function SetStatePermissionsHack($documentId)
	{
		global $DB;
		$arStatePermissions = $this->Permission; // массив полномочий
		$workflowId = trim($this->GetWorkflowInstanceId()); // ИД БП
		$bRewrite = $this->Rewrite; // наш способ работы с правами
		list($moduleId, $entity, $documentType) = $this->GetDocumentType(); // дёргаем тип документа
		
		if (strlen($workflowId) <= 0)
			throw new Exception("workflowId");

		/* === Блок работы со штатными правами БП из DocumentService->SetStatePermissions ===
		   Идеологически плохой и неправильный кусок, так как база может поменяться, а активити менять за вас никто не будет.
		   Но, выбора, в общем-то, нет */
		if (in_array($bRewrite, array(self::ClearPermissions, self::ClearAllPermissions)))
		{
			$DB->Query(
				"DELETE FROM b_bp_workflow_permissions ".
				"WHERE WORKFLOW_ID = '".$DB->ForSql($workflowId)."' "
			);
		}

		/* Как видно ниже, написан он тоже не ахти, никакой защиты от дублей и пустышек, просто фигачим всё, что есть, поэтому в правах БП часто много мусора */
		foreach ($arStatePermissions as $taskId => $arUsers)
		{
			foreach ($arUsers as $user)
			{
				$DB->Query(
					"INSERT INTO b_bp_workflow_permissions (WORKFLOW_ID, OBJECT_ID, PERMISSION) ".
					"VALUES ('".$DB->ForSql($workflowId)."', '".$DB->ForSql($user)."', '".$DB->ForSql($taskId)."')"
				);
			}
		}
		/* === Конец блока работы со штатными правами БП === */

		$documentId = intval($documentId);
		if ($documentId <= 0)
			throw new CBPArgumentNullException("documentId");

		$iblockId = intval(substr($documentType, strlen("iblock_")));
		if ($iblockId <= 0)
			throw new CBPArgumentOutOfRangeException("documentType", $documentType);

		if (CIBlock::GetArrayByID($iblockId, "RIGHTS_MODE") !== "E") // нас интересуют только расширенные права
			return;

		$i = 0;
		$l = strlen("user_");
		$arNew = array(); // Массив новых прав
		$arNewGroupCodes = array(); // Группкоды новых прав
		foreach ($arStatePermissions as $taskId => $arUsers)
		{
			foreach ($arUsers as $user)
			{
				if (!empty($user))
				{
					$gc = null;
					if ($user == 'author')
					{
						$gc = "CR"; // Родная роль "Автор" инфоблоков, вместо использования конкретного пользователя, как сейчас. Позволяет гибче управлять правами в дальнейшем
					}
					elseif (substr($user,0,2) != "{=") // тупозащита для отсечения переданных данных не о юзере, а макросов переменных или параметров. игнорим, чтобы не было мусора в правах иб
					{
						$gc = ((substr($user, 0, $l) == "user_") ? "U".substr($user, $l) : "G".$user); // либо юзер, либо юзергрупп, другое не поддерживаем
					}
					if ($gc != null)
					{
						$arNew["n".$i] = array("GROUP_CODE" => $gc, "TASK_ID" => $taskId, "XML_ID" => $workflowId); // забиваем массив новых прав
						$arNewGroupCodes[] = $gc; // сохраняем группкод для дальнейшего парсинга старых прав
						$i++;
					}
				}
			}
		}

		$ob = new CIBlockElementRights($iblockId, $documentId); // создаём объект прав и инициализируем нашим элементом

		if ($bRewrite == self::ClearAllPermissions) // если нам не нужны старые права, мы их просто не извлекаем, делаем пустой массив
			$ar = array();
		else // иначе дёргаем текущие права на элемент
			$ar = $ob->GetRights();

		if ($bRewrite != self::AddPermissions && $bRewrite != self::ClearAllPermissions) // парсим права только если надо
		{
			foreach ($ar as $i => $arRight)
			{
				if ($bRewrite == self::ClearPermissions && $arRight["XML_ID"] == $workflowId) // если очищаем старые права данного БП
					unset($ar[$i]);
				elseif ($bRewrite == self::RewritePermissions && $arRight["XML_ID"] == $workflowId && in_array($arRight["GROUP_CODE"], $arNewGroupCodes)) // если заменяем права данного БП при совпадении группкода
					unset($ar[$i]);
				elseif ($bRewrite == self::RewriteAllPermissions && in_array($arRight["GROUP_CODE"], $arNewGroupCodes)) // если заменяем любые права при совпадении
					unset($ar[$i]);
			}
		}
		$ar = $ar+$arNew; // склеиваем массивы без потери ключей

		$ob->SetRights($ar); // устанавливаем права на элемент, радуемся
	}
	
	public function Execute()
	{
		// модифицируем метод, вебдав и иблоки отправляем по новому пути, всё остальное - по старому
		list($moduleId, $entity, $documentId) = CBPHelper::ParseDocumentId($this->GetDocumentId());
		if ($moduleId == "iblock" || $moduleId == "webdav")
			$this->SetStatePermissionsHack($documentId); // используем нашу функцию
		else
		{
			$bRewriteOld = true; // стандартный тип перезаписи прав
			if ($this->Rewrite == self::AddPermissions) // не стираем старые права только в одном случае
				$bRewriteOld = false;
			$stateService = $this->workflow->GetService("StateService");
			$stateService->SetStatePermissions($this->GetWorkflowInstanceId(), $this->Permission, $bRewriteOld);
		}
			
		return CBPActivityExecutionStatus::Closed;
	}

	public static function GetPropertiesDialog($documentType, $activityName, $arWorkflowTemplate, $arWorkflowParameters, $arWorkflowVariables, $arCurrentValues = null, $formName = "")
	{
		$runtime = CBPRuntime::GetRuntime();

		$documentService = $runtime->GetService("DocumentService");
		$arAllowableOperations = $documentService->GetAllowableOperations($documentType);

		if (!is_array($arCurrentValues))
		{
			$arCurrentActivity = &CBPWorkflowTemplateLoader::FindActivityByName($arWorkflowTemplate, $activityName);
			if (is_array($arCurrentActivity["Properties"]) && array_key_exists("Permission", $arCurrentActivity["Properties"]))
			{
				foreach ($arAllowableOperations as $operationKey => $operationValue)
				{
					$arCurrentValues["permission_".$operationKey] = CBPHelper::UsersArrayToString(
						$arCurrentActivity["Properties"]["Permission"][$operationKey],
						$arWorkflowTemplate,
						$documentType
					);
				}
			}

			if (array_key_exists("Rewrite", $arCurrentActivity["Properties"]))
			{
				$arCurrentValues["rewrite"] = $arCurrentActivity["Properties"]["Rewrite"];
			}
			else
				$arCurrentValues["rewrite"] = self::ClearPermissions;
		}

		return $runtime->ExecuteResourceFile(
			__FILE__,
			"properties_dialog.php",
			array(
				"arAllowableOperations" => $arAllowableOperations,
				"arCurrentValues" => $arCurrentValues,
				"formName" => $formName,
			)
		);
	}

	public static function GetPropertiesDialogValues($documentType, $activityName, &$arWorkflowTemplate, &$arWorkflowParameters, &$arWorkflowVariables, $arCurrentValues, &$arErrors)
	{
		$arErrors = array();

		$runtime = CBPRuntime::GetRuntime();

		$arProperties = array("Permission" => array(), "Rewrite" => self::ClearPermissions);

		$documentService = $runtime->GetService("DocumentService");
		$arAllowableOperations = $documentService->GetAllowableOperations($documentType);

		foreach ($arAllowableOperations as $operationKey => $operationValue)
		{
			$arProperties["Permission"][$operationKey] = CBPHelper::UsersStringToArray($arCurrentValues["permission_".$operationKey], $documentType, $arErrors);
			if (count($arErrors) > 0)
				return false;
		}

		$arProperties["Rewrite"] = $arCurrentValues["rewrite"];

		$arErrors = self::ValidateProperties($arProperties, new CBPWorkflowTemplateUser(CBPWorkflowTemplateUser::CurrentUser));
		if (count($arErrors) > 0)
			return false;

		$arCurrentActivity = &CBPWorkflowTemplateLoader::FindActivityByName($arWorkflowTemplate, $activityName);
		$arCurrentActivity["Properties"] = $arProperties;

		return true;
	}
}
?>